]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- reenabled UTF-8 check for AC-branch
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
cd445739
AM
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
8f40d368 25v0.18 (C) 1999-2007 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
47761337 40NOINIT=""
cd445739 41UPDATE=""
cd445739
AM
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
d1c5a9a7 64RPMBUILDOPTS=""
cd445739
AM
65BCOND=""
66GROUP_BCONDS="no"
947025e5 67CVSIGNORE_DF="no"
d287305c 68
69PATCHES=""
70SOURCES=""
cd445739 71ICONS=""
d287305c 72PACKAGE_RELEASE=""
73PACKAGE_VERSION=""
74PACKAGE_NAME=""
cd445739
AM
75PROTOCOL="ftp"
76WGET_RETRIES=${MAX_WGET_RETRIES:-0}
77CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
78
79CVSTAG=""
80RES_FILE=""
39dcc7de 81CVS_FORCE=""
cd445739
AM
82
83CVS_SERVER="cvs.pld-linux.org"
84DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 85ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 86
36d03934 87DEF_NICE_LEVEL=19
86aafdbe 88SCHEDTOOL="auto"
cd445739
AM
89
90FAIL_IF_NO_SOURCES="yes"
91
18e5347d
ER
92# let get_files skip over files which are present to get those damn files fetched
93SKIP_EXISTING_FILES="no"
94
975d7b23 95TRY_UPGRADE=""
257af81b
ER
96# should the specfile be restored if upgrade failed?
97REVERT_BROKEN_UPGRADE="yes"
98
ab4a2b6e 99if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 100 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 101else
ce40491a 102 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
103fi
104
cd445739
AM
105# Here we load saved user environment used to
106# predefine options set above, or passed to builder
107# in command line.
108# This one reads global system environment settings:
109if [ -f ~/etc/builderrc ]; then
110 . ~/etc/builderrc
111fi
112# And this one cascades settings using user personal
113# builder settings.
114# Example of ~/.builderrc:
115#
116#UPDATE_POLDEK_INDEXES="yes"
117#FETCH_BUILD_REQUIRES="yes"
118#REMOVE_BUILD_REQUIRES="force"
119#GROUP_BCONDS="yes"
120#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 121#TITLECHANGE=no
cd445739 122#
a83e5405 123SU_SUDO=""
cd445739
AM
124if [ -n "$HOME_ETC" ]; then
125 USER_CFG="$HOME_ETC/.builderrc"
126else
127 USER_CFG=~/.builderrc
128fi
129
130[ -f "$USER_CFG" ] && . "$USER_CFG"
131
86aafdbe
ER
132if [ "$SCHEDTOOL" = "auto" ]; then
133 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
134 SCHEDTOOL="schedtool -B -e"
135 else
136 SCHEDTOOL="no"
137 fi
138fi
139
ca2e6c31 140if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
141 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
142 GETURI2="$GETURI"
143 OUTFILEOPT="-O"
ca2e6c31 144elif [ -n "$USE_AXEL" ]; then
cede92b3 145 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
146 GETURI2="$GETURI"
147 OUTFILEOPT="-o"
ca2e6c31 148else
5700ee32
ER
149 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
150 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
151 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 152
7e365483
KK
153 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
154 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
155 OUTFILEOPT="-O"
2bc5451f 156fi
11468b23 157
11468b23
AM
158GETLOCAL="cp -a"
159
160if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
161 RPM="rpm"
162 RPMBUILD="rpm"
163else
164 RPM="rpm"
165 RPMBUILD="rpmbuild"
166fi
167
168POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 169POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 170
cd445739
AM
171run_poldek()
172{
173 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
174 if [ -n "$LOGFILE" ]; then
175 LOG=`eval echo $LOGFILE`
176 if [ -n "$LASTLOG_FILE" ]; then
177 echo "LASTLOG=$LOG" > $LASTLOG_FILE
178 fi
86aafdbe 179 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
180 return $exit_pldk
181 else
86aafdbe 182 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
183 return `cat ${RES_FILE}`
184 rm -rf ${RES_FILE}
185 fi
186}
187
cd445739
AM
188#---------------------------------------------
189# functions
da946cd6 190
5a491465 191usage()
192{
cd445739
AM
193 if [ -n "$DEBUG" ]; then set -xv; fi
194 echo "\
195Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
6594293d 196[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 197[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 198[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
199[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 200[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
cd445739 201[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d 202[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 203[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
6594293d 204<package>[.spec][:cvstag]
2a5f078d 205
cd445739
AM
206-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
207-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
208-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
209-D, --debug - enable builder script debugging mode,
210-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
211-V, --version - output builder version
212-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
213-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
214 from <package>.spec,
215-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
216 only package from <package>.spec,
c56807e0 217-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
218-bc - execute the %build phase of <package>.spec,
219-bi - execute the %install phase of <package>.spec
220-bl - execute the %files phase of <package>.spec
cd445739
AM
221-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
222 them into src.rpm,
6594293d 223--short-circuit - short-circuit build
cd445739
AM
224-B, --branch - add branch
225-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
226 SPECS and \$RPM_BUILD_ROOT),
39dcc7de 227-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 228-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
229 - setup \$CVSROOT,
230--define <macro> <value>
231 - define a macro <macro> with value <value>,
232--nodeps - rpm won't check any dependences
233-g, --get - get <package>.spec and all related files from CVS repo
234 or HTTP/FTP,
235-h, --help - this message,
236--http - use http instead of ftp,
237-l <logfile>, --logtofile <logfile>
238 - log all to file,
239-m, --mr-proper - only remove all files related to spec file and all work
240 resources,
241-nc, --no-cvs - don't download sources from CVS, if source URL is given,
242-ncs, --no-cvs-specs
243 - don't check specs in CVS
244-nd, --no-distfiles - don't download from distfiles
245-nm, --no-mirrors - don't download from mirror, if source URL is given,
246-nu, --no-urls - don't try to download from FTP/HTTP location,
247-ns, --no-srcs - don't download Sources
248-ns0, --no-source0 - don't download Source0
249-nn, --no-net - don't download anything from the net
b572253e 250--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
251-ske,
252--skip-existing-files - skip existing files in get_files
cd445739
AM
253--opts <rpm opts> - additional options for rpm
254-q, --quiet - be quiet,
255--date yyyy-mm-dd - build package using resources from specified CVS date,
256-r <cvstag>, --cvstag <cvstag>
257 - build package using resources from specified CVS tag,
5323fffd 258-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
259-R, --fetch-build-requires
260 - fetch what is BuildRequired,
261-RB, --remove-build-requires
262 - remove all you fetched with -R or --fetch-build-requires
263 remember, this option requires confirmation,
264-FRB, --force-remove-build-requires
265 - remove all you fetched with -R or --fetch-build-requires
266 remember, this option works without confirmation,
06541433
JR
267-sd, --source-distfiles - list sources available from distfiles (intended for offline
268 operations; does not work when Icon field is present
269 but icon file is absent),
270-sdp, --source-distfiles-paths - list sources available from distfiles -
271 paths relative to distfiles directory (intended for offline
272 operations; does not work when Icon field is present
273 but icon file is absent),
a7eefc54 274-sf, --source-files - list sources - bare filenames (intended for offline
275 operations; does not work when Icon field is present
3621e588 276 but icon file is absent),
a7eefc54 277-sp, --source-paths - list sources - filenames with full local paths (intended for
278 offline operations; does not work when Icon field is present
3621e588 279 but icon file is absent),
2dddf439
ER
280-su, --source-urls - list urls - urls to sources and patches
281 intended for copying urls with spec with lots of macros in urls
cd445739
AM
282-T <cvstag> , --tag <cvstag>
283 - add cvs tag <cvstag> for files,
284-Tvs, --tag-version-stable
094bd95b 285 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
286-Ts, --tag-stable
287 - add cvs tag STABLE for files,
cd445739 288-Tv, --tag-version
1691a37b 289 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
290-Tp, --tag-prefix <prefix>
291 - add <prefix> to NAME-VERSION-RELEASE tags,
292-tt, --test-tag <prefix>
293 - fail if tag is already present,
50321881
JK
294-ir, --integer-release-only
295 - allow only integer and snapshot releases
cd445739
AM
296-v, --verbose - be verbose,
297-u, --try-upgrade - check version, and try to upgrade package
298-un, --try-upgrade-with-float-version
299 - as above, but allow float version
deccc50e 300-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
301-Upi, --update-poldek-indexes
302 - refresh or make poldek package index files.
c890b916 303-np, --nopatch <patchnumber>
bed98670 304 - don't apply <patchnumber>
dfe2cb9a
MK
305--show-bconds - show available conditional builds, which can be used
306 - with --with and/or --without switches.
9b78be50
ER
307--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
308 ./repackage.sh script. in other words, the output is
309 parseable by scripts.
cd445739
AM
310--with/--without <feature>
311 - conditional build package depending on %_with_<feature>/
312 %_without_<feature> macro switch. You may now use
313 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
314 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 315--target <platform>, --target=<platform>
3621e588
ER
316 - build for platform <platform>.
317--init-rpm-dir - initialize ~/rpm directory structure
5a491465 318"
319}
320
c890b916 321update_shell_title() {
a0d6396b 322 [ -t 1 ] || return
0b65d15e
ER
323 local len=${COLUMNS:-80}
324 local msg=$(echo "$*" | cut -c-$len)
325
e225de91
ER
326 if [ -n "$BE_VERBOSE" ]; then
327 echo >&2 "$(date +%s.%N) $*"
328 fi
329
982e358c 330 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
331 local pkg
332 if [ -n "$PACKAGE_NAME" ]; then
333 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
334 else
335 pkg=${SPECFILE}
336 fi
337
338 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 339 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
340 case "$TERM" in
341 cygwin|xterm*)
342 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
343 ;;
344 screen*)
345 echo >&2 -ne "\033]0;$msg\007"
346 ;;
347 esac
348 fi
c890b916
ER
349}
350
7e40520f
ER
351# set TARGET from BuildArch: from SPECFILE
352set_spec_target() {
ce40491a
ER
353 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
354 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
355 if [ "$tmp" ]; then
f9109a96 356 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
357 TARGET="$tmp"
358 case "$RPMBUILD" in
359 "rpmbuild")
f9109a96 360 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 361 "rpm")
ce40491a 362 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 363 esac
ce40491a
ER
364 fi
365 fi
7e40520f
ER
366}
367
cd445739 368cache_rpm_dump () {
d22150da 369 if [ -n "$DEBUG" ]; then
518ff1fb
ER
370 set -x
371 set -v
d22150da 372 fi
7e40520f 373
13974367 374 update_shell_title "cache_rpm_dump"
237bd3f1
ER
375 local rpm_dump
376 rpm_dump=`
d05e8080 377
fa4bf1df 378 # we reset macros not to contain macros.build as all the %() macros are
559d511f 379 # executed here, while none of them are actually needed.
fa4bf1df 380 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
559d511f 381 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
36433112 382 macrofiles="/usr/lib/rpm/macros:$SPECS_DIR/.builder-rpmmacros:~/etc/.rpmmacros:~/.rpmmacros"
237bd3f1 383 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
8ebeba63
AM
384 if [ -f /usr/lib/rpm/rpmrc ]; then
385 # FIXME: better ideas than .rpmrc?
386 printf 'include:/usr/lib/rpm/rpmrc\nmacrofiles:%s\n' $macrofiles > .builder-rpmrc
387 else
388 printf 'macrofiles:%s\n' $macrofiles > .builder-rpmrc
389 fi
fb198857 390# TODO: move these to /usr/lib/rpm/macros
36433112 391 cat > .builder-rpmmacros <<'EOF'
f78a0bb7 392%alt_kernel %{nil}
393%_alt_kernel %{nil}
fb198857
ER
394%requires_releq_kernel_up %{nil}
395%requires_releq_kernel_smp %{nil}
6b8134e3 396%requires_releq() %{nil}
bb01dee9 397%pyrequires_eq() %{nil}
559d511f 398%requires_eq() %{nil}
c13be3d1 399%requires_eq_to() %{nil}
fb198857
ER
400%releq_kernel_up ERROR
401%releq_kernel_smp ERROR
74d9fd14 402%kgcc_package ERROR
237bd3f1 403%_fontsdir ERROR
7141278d 404%ruby_version ERROR
405%ruby_ver_requires_eq() %{nil}
406%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 407%__php_api_requires() %{nil}
7141278d 408%php_major_version ERROR
409%php_api_version ERROR
410%py_ver ERROR
41035426
ER
411%perl_vendorarch ERROR
412%perl_vendorlib ERROR
703ae20b
ER
413# damn. need it here! - copied from /usr/lib/rpm/macros.build
414%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
415%patchset_source(f:b:) %(
416 base=%{-b*}%{!-b*:10000};
417 start=$(expr $base + %1);
418 end=$(expr $base + %{?2}%{!?2:%{1}});
419 # we need to call seq twice as it doesn't allow two formats
420 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
421 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
422 paste %{tmpdir}/__ps{1,2};
423 rm -f %{tmpdir}/__ps{1,2};
424) \
425%{nil}
fb198857 426EOF
cd445739 427 case "$RPMBUILD" in
237bd3f1
ER
428 rpm)
429 ARGS='-bp'
430 ;;
431 rpmbuild)
432 ARGS='--nodigest --nosignature --nobuild'
433 ;;
434 esac
3d12d055
JR
435 if [ "$NOINIT" = "yes" ] ; then
436 cat >> .builder-rpmmacros <<'EOF'
437%_specdir ./
438%_sourcedir ./
439EOF
c039643c
JR
440 fi
441 $RPMBUILD --rcfile .builder-rpmrc $ARGS $ARGDIRS --nodeps --define "prep $dump" $BCOND $TARGET_SWITCH $SPECFILE 2>&1
237bd3f1 442 `
fb198857 443 if [ $? -gt 0 ]; then
237bd3f1
ER
444 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
445 echo "$error" >&2
518ff1fb 446 Exit_error err_build_fail
fb198857 447 fi
d05e8080
ER
448
449 # make small dump cache
450 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
451 $2 ~ /^SOURCEURL/ {print}
452 $2 ~ /^PATCHURL/ {print}
453 $2 ~ /^nosource/ {print}
454 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
455 '`
456
13974367 457 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
458}
459
460rpm_dump () {
461 if [ -z "$rpm_dump_cache" ] ; then
d7b4d36e 462 echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
cd445739
AM
463 fi
464 echo "$rpm_dump_cache"
465}
466
d05e8080
ER
467get_icons()
468{
469 update_shell_title "get icons"
470 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
471 if [ -z "$ICONS" ]; then
472 return
473 fi
474
975d7b23 475 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
476}
477
59398507 478parse_spec()
479{
af4d5315 480 update_shell_title "parsing specfile"
cd445739 481 if [ -n "$DEBUG" ]; then
518ff1fb
ER
482 set -x
483 set -v
cd445739 484 fi
b2975fc3 485
d05e8080 486 # icons are needed for successful spec parse
518ff1fb 487 get_icons
d05e8080 488
cd445739 489 cd $SPECS_DIR
cd445739 490 cache_rpm_dump
00fcec7e 491
cd445739
AM
492 if [ "$NOSRCS" != "yes" ]; then
493 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
494 fi
7cb24972 495
cd445739
AM
496 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
497 FAIL_IF_NO_SOURCES="no"
498 fi
499
500 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
501 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
fa4bf1df
ER
502 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3}')
503 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3}')
504 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3}')
78eab2a1 505
cd445739
AM
506 if [ -n "$BE_VERBOSE" ]; then
507 echo "- Sources : `nourl $SOURCES`"
508 if [ -n "$PATCHES" ]; then
509 echo "- Patches : `nourl $PATCHES`"
510 else
511 echo "- Patches : *no patches needed*"
512 fi
513 if [ -n "$ICONS" ]; then
514 echo "- Icon : `nourl $ICONS`"
515 else
516 echo "- Icon : *no package icon*"
517 fi
518 echo "- Name : $PACKAGE_NAME"
519 echo "- Version : $PACKAGE_VERSION"
520 echo "- Release : $PACKAGE_RELEASE"
521 fi
13974367
ER
522
523 update_shell_title "parse_spec: OK!"
cd445739
AM
524}
525
526Exit_error()
527{
528 if [ -n "$DEBUG" ]; then
518ff1fb
ER
529 set -x
530 set -v
cd445739
AM
531 fi
532
533 cd "$__PWD"
534
535 case "$1" in
536 "err_no_spec_in_cmdl" )
537 remove_build_requires
518ff1fb 538 echo "ERROR: spec file name not specified."
cd445739 539 exit 2 ;;
a08d92fc
ER
540 "err_invalid_cmdline" )
541 echo "ERROR: invalid command line arg ($2)."
542 exit 2 ;;
cd445739
AM
543 "err_no_spec_in_repo" )
544 remove_build_requires
518ff1fb 545 echo "Error: spec file not stored in CVS repo."
cd445739
AM
546 exit 3 ;;
547 "err_no_source_in_repo" )
548 remove_build_requires
518ff1fb 549 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
550 exit 4 ;;
551 "err_build_fail" )
552 remove_build_requires
518ff1fb 553 echo "Error: package build failed. (${2:-no more info})"
cd445739 554 exit 5 ;;
78eab2a1
AM
555 "err_no_package_data" )
556 remove_build_requires
557 echo "Error: couldn't get out package name/version/release from spec file."
558 exit 6 ;;
ce40491a 559 "err_tag_exists" )
50321881 560 remove_build_requires
518ff1fb 561 echo "Tag ${2} already exists (spec release: ${3})."
50321881 562 exit 9 ;;
ce40491a 563 "err_fract_rel" )
50321881 564 remove_build_requires
518ff1fb 565 echo "Release ${2} not integer and not a snapshot."
50321881 566 exit 10 ;;
fb96e0b5
AM
567 "err_branch_exists" )
568 remove_build_requires
518ff1fb 569 echo "Tree branch already exists (${2})."
fb96e0b5 570 exit 11 ;;
cfc497c0
ER
571 "err_acl_deny" )
572 remove_build_requires
573 echo "Error: conditions reject building this spec (${2})."
574 exit 12 ;;
50321881 575
cd445739 576 esac
73848362
ER
577 echo "Unknown error."
578 exit 100
cd445739
AM
579}
580
581init_builder()
582{
583 if [ -n "$DEBUG" ]; then
518ff1fb
ER
584 set -x
585 set -v
0dd6320d 586 fi
cd445739 587
4aeb9973 588 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
589 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
590 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
591 else
592 SOURCE_DIR="."
593 SPECS_DIR="."
594 fi
cd445739
AM
595
596 __PWD="`pwd`"
00fcec7e 597}
598
d6a77ddb 599get_spec()
1471f6d6 600{
c890b916 601
2e5be021 602 update_shell_title "get_spec"
c890b916 603
cd445739 604 if [ -n "$DEBUG" ]; then
518ff1fb
ER
605 set -x
606 set -v
cd445739
AM
607 fi
608
609 cd "$SPECS_DIR"
049ab214 610 if [ ! -f "$SPECFILE" ]; then
518ff1fb 611 SPECFILE="`basename $SPECFILE .spec`.spec"
cd445739
AM
612 fi
613 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 614
049ab214
ER
615 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
616 echo "Warning: No CVS access defined - using local .spec file"
617 NOCVSSPEC="yes"
cd445739
AM
618 fi
619
049ab214 620 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 621 fi
049ab214 622
cd445739 623 if [ ! -f "$SPECFILE" ]; then
518ff1fb 624 Exit_error err_no_spec_in_repo
cd445739
AM
625 fi
626
627 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
628 chmod $CHMOD_MODE $SPECFILE
629 fi
630 unset OPTIONS
a7eefc54 631 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 632
ce40491a 633 set_spec_target
cd445739
AM
634}
635
636find_mirror()
637{
638 cd "$SPECS_DIR"
782518da 639 local url="$1"
cd445739
AM
640 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
641 cvs update mirrors >&2
642 fi
643
644 IFS="|"
782518da
ER
645 local origin mirror name rest ol prefix
646 while read origin mirror name rest; do
647 # skip comments and empty lines
648 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
649 continue
650 fi
cd445739
AM
651 ol=`echo -n "$origin"|wc -c`
652 prefix="`echo -n "$url" | head -c $ol`"
653 if [ "$prefix" = "$origin" ] ; then
782518da 654 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
655 echo -n "$mirror$suffix"
656 return 0
657 fi
658 done < mirrors
659 echo "$url"
660}
661
e7e0d4ec 662# Warning: unpredictable results if same URL used twice
cd445739
AM
663src_no ()
664{
665 cd $SPECS_DIR
666 rpm_dump | \
667 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
668 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
669 head -n 1 | xargs
1471f6d6 670}
671
e7e0d4ec 672src_md5()
8ba5cdda 673{
e7e0d4ec 674 [ "$NO5" = "yes" ] && return
cd445739
AM
675 no=$(src_no "$1")
676 [ -z "$no" ] && return
677 cd $SPECS_DIR
e7e0d4ec
ER
678 local md5
679
680 if [ -f additional-md5sums ]; then
681 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
682 if [ -z "$spec_rev" ]; then
683 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
684 fi
685 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
686 md5=$(grep -s -v '^#' additional-md5sums | \
687 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
688 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
689 grep -E '^[0-9a-f]{32}$')
690
691 if [ "$md5" ]; then
692 if [ $(echo "$md5" | wc -l) != 1 ] ; then
693 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
694 fi
695 echo "$md5" | tail -n 1
696 return
697 fi
cd445739 698 fi
e7e0d4ec
ER
699
700 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
701 if [ -n "$source_md5" ]; then
702 echo $source_md5
cd445739 703 else
e7e0d4ec
ER
704 # we have empty SourceX-md5, but it is still possible
705 # that we have NoSourceX-md5 AND NoSource: X
706 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
03db3356 707 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
e7e0d4ec 708 echo $nosource_md5
cd445739 709 fi
cd445739
AM
710 fi
711}
712
06541433
JR
713distfiles_path ()
714{
715 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
716}
717
cd445739
AM
718distfiles_url ()
719{
06541433 720 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
721}
722
723distfiles_attic_url ()
724{
06541433 725 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
726}
727
728good_md5 ()
729{
730 md5=$(src_md5 "$1")
731 [ "$md5" = "" ] || \
732 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
733}
734
a4b50627
AF
735good_size ()
736{
ce40491a
ER
737 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
738 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
739}
740
947025e5 741cvsignore_df ()
742{
743 if [ "$CVSIGNORE_DF" != "yes" ]; then
744 return
745 fi
746 cvsignore=${SOURCE_DIR}/.cvsignore
747 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
748 echo "$1" >> $cvsignore
749 fi
750}
751
e7fa3b9f
ER
752cvsup()
753{
ce40491a
ER
754 update_shell_title "cvsup"
755 local OPTIONS="up "
756 if [ -n "$CVSROOT" ]; then
757 OPTIONS="-d $CVSROOT $OPTIONS"
758 fi
b1c6aace 759
ce40491a
ER
760 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
761 OPTIONS="$OPTIONS -A"
762 else
763 if [ -n "$CVSDATE" ]; then
764 OPTIONS="$OPTIONS -D $CVSDATE"
765 fi
766 if [ -n "$CVSTAG" ]; then
767 OPTIONS="$OPTIONS -r $CVSTAG"
768 fi
769 fi
e7fa3b9f 770
ce40491a
ER
771 local result=1
772 local retries_counter=0
773 if [ $# = 1 ]; then
774 update_shell_title "cvsup: $*"
775 else
776 update_shell_title "cvsup: $# files"
777 fi
778 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
779 retries_counter=$(( $retries_counter + 1 ))
780 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
781 result=$?
782 [ -n "$output" ] && echo "$output"
783 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
784 echo "Trying again [$*]... ($retries_counter)"
785 update_shell_title "cvsup: retry #$retries_counter"
786 sleep 2
787 continue
788 else
789 break
790 fi
791 done
792 update_shell_title "cvsup: done!"
793 return $result
e7fa3b9f
ER
794}
795
71f8e908
ER
796# returns true if "$1" is ftp, http or https protocol url
797is_url()
798{
799 case "$1" in
800 ftp://*|http://*|https://*)
801 return 0
802 ;;
803 esac
804 return 1
805}
806
ecba6ad5
ER
807update_md5()
808{
809 if [ $# -eq 0 ]; then
810 return
811 fi
812
813 update_shell_title "update md5"
814 if [ -n "$DEBUG" ]; then
518ff1fb
ER
815 set -x
816 set -v
ecba6ad5
ER
817 fi
818
819 cd "$SOURCE_DIR"
820
821 # pass 1: check files to be fetched
822 local todo
823 local need_files
824 for i in "$@"; do
825 local fp=$(nourl "$i")
826 local srcno=$(src_no "$i")
6392b5fd
ER
827 if [ -n "$ADD5" ]; then
828 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
829 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
830 else
831 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
ecba6ad5
ER
832 fi
833 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
834 need_files="$need_files $i"
835 fi
836 done
837
838 # pass 1a: get needed files
839 if [ "$need_files" ]; then
840 get_files $need_files
841 fi
842
843 # pass 2: proceed with md5 adding or updating
844 for i in "$@"; do
845 local fp=$(nourl "$i")
846 local srcno=$(src_no "$i")
71f8e908
ER
847 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
848 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
849 local tag="Source$srcno-md5"
850 if [[ "$md5" == *NoSource* ]]; then
851 tag="NoSource$srcno-md5"
852 fi
ecba6ad5 853 md5=$(md5sum "$fp" | cut -f1 -d' ')
4efa0b98 854 echo "Updating $tag ($md5: $fp)."
ecba6ad5 855 perl -i -ne '
71f8e908
ER
856 print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
857 print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5
ER
858 ' \
859 $SPECS_DIR/$SPECFILE
860 fi
861 done
862}
863
864check_md5()
865{
866 update_shell_title "check md5"
867
868 for i in "$@"; do
869 if good_md5 "$i" && good_size "$i"; then
870 continue
871 fi
872
873 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
874 echo "or -5 to update md5 sums, if you're sure files are correct."
875 Exit_error err_no_source_in_repo $i
876 done
877}
878
cd445739
AM
879get_files()
880{
7cb24972 881 update_shell_title "get_files"
cd445739
AM
882
883 if [ -n "$DEBUG" ]; then
518ff1fb
ER
884 set -x
885 set -v
cd445739
AM
886 fi
887
f09c0772 888 if [ $# -gt 0 ]; then
cd445739
AM
889 cd "$SOURCE_DIR"
890
b1c6aace 891 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 892 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
893 NOCVS="yes"
894 fi
895
f2e42a41 896 local nc=0
e7fa3b9f 897 local get_files_cvs=""
3815b69a 898 for i in "$@"; do
f2e42a41 899 nc=$((nc + 1))
dcebdffb 900 local cvsup=0
3815b69a 901 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 902 update_shell_title "$i"
f09c0772 903 local fp=`nourl "$i"`
ecba6ad5 904 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 905 continue
18e5347d 906 fi
ecba6ad5 907
cd445739 908 FROM_DISTFILES=0
e7e0d4ec 909 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
910
911 # we know if source/patch is present in cvs/distfiles
912 # - has md5 (in distfiles)
913 # - in cvs... ideas?
914
915 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 916 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
917 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
918 echo "Warning: no URL given for $i"
919 fi
920
e7e0d4ec 921 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 922 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 923 echo "$fp having proper md5sum already exists"
cd445739
AM
924 continue
925 fi
4ea1c265 926 target="$fp"
28b34560
ER
927
928 # prefer mirror over distfiles if there's mirror
929 # TODO: build url list and then try each url from the list
930 if [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
931 url="$im"
932 else
933 url=$(distfiles_url "$i")
934 fi
935
cd445739
AM
936 url_attic=$(distfiles_attic_url "$i")
937 FROM_DISTFILES=1
ecba6ad5
ER
938 # is $url local file?
939 if [[ "$url" = [./]* ]]; then
18a52930 940 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
941 ${GETLOCAL} $url $target
942 else
943 if [ -z "$NOMIRRORS" ]; then
9e9f8920 944 url=$(find_mirror "$url")
cd445739 945 fi
9e9f8920
ER
946
947 local uri=${url}
948 # make shorter message for distfiles urls
949 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
950 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
951 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
952 uri="df: $uri"
953 fi
954 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 955 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 956 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 957 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 958 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
959 fi
960 fi
ecba6ad5
ER
961
962 # is it empty file?
963 if [ ! -s "$target" ]; then
cd445739
AM
964 rm -f "$target"
965 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 966 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
967 ${GETLOCAL} $url_attic $target
968 else
969 if [ -z "$NOMIRRORS" ]; then
970 url_attic="`find_mirror "$url_attic"`"
971 fi
18a52930 972 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 973 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 974 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 975 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 976 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
977 fi
978 fi
979 fi
ecba6ad5
ER
980
981 if [ -s "$target" ]; then
947025e5 982 cvsignore_df $target
983 else
cd445739
AM
984 rm -f "$target"
985 FROM_DISTFILES=0
986 fi
e7e0d4ec 987 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
988 if [ $# -gt 1 ]; then
989 get_files_cvs="$get_files_cvs $fp"
990 update_shell_title "$fp (will cvs up later)"
991 cvsup=1
992 else
993 cvsup $fp
994 fi
cd445739
AM
995 fi
996
f09c0772 997 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
998 if [ -z "$NOMIRRORS" ]; then
999 im="`find_mirror "$i"`"
1000 else
1001 im="$i"
1002 fi
ce40491a 1003 update_shell_title "${GETURI%% *}: $im"
cd445739 1004 ${GETURI} "$im" || \
33da77c4 1005 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1006 update_shell_title "${GETURI2%% *}: $im"
cd445739 1007 ${GETURI2} "$im"
7e365483 1008 fi
cd445739
AM
1009 fi
1010
dcebdffb
ER
1011 if [ "$cvsup" = 1 ]; then
1012 continue
1013 fi
1014
cd445739 1015 fi
ecba6ad5
ER
1016
1017 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1018 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
518ff1fb 1019 Exit_error err_no_source_in_repo $i
cd445739 1020 fi
2a5f078d 1021
ecba6ad5 1022 # we check md5 here just only to refetch immediately
a4b50627 1023 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1024 :
1025 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1026 # wrong md5 from distfiles: remove the file and try again
cd445739 1027 # but only once ...
deccc50e 1028 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1029 FROM_DISTFILES=2
1030 rm -f $target
18a52930 1031 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1032 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1033 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1034 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1035 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1036 fi
ecba6ad5 1037 if [ ! -s "$target" ]; then
cd445739 1038 rm -f "$target"
18a52930 1039 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1040 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1041 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1042 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1043 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1044 fi
1045 fi
1046 test -s "$target" || rm -f "$target"
1047 fi
cd445739 1048 done
e7fa3b9f
ER
1049 SHELL_TITLE_PREFIX=""
1050
1051 if [ "$get_files_cvs" ]; then
ce40491a 1052 cvsup $get_files_cvs
e7fa3b9f 1053 fi
cd445739
AM
1054
1055 if [ "$CHMOD" = "yes" ]; then
3815b69a 1056 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
1057 if [ -n "$CHMOD_FILES" ]; then
1058 chmod $CHMOD_MODE $CHMOD_FILES
1059 fi
1060 fi
cd445739
AM
1061 fi
1062}
1063
1064make_tagver() {
ce40491a 1065 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1066 set -x
1067 set -v
ce40491a 1068 fi
78eab2a1 1069
ce40491a
ER
1070 # Check whether first character of PACKAGE_NAME is legal for tag name
1071 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1072 TAG_PREFIX=tag_
1073 fi
1074 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
1075 # Remove #kernel.version_release from TAGVER because tagging sources
1076 # could occur with different kernel-headers than kernel-headers used at build time.
1077 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
1078 echo -n "$TAGVER"
cd445739
AM
1079}
1080
1081tag_files()
1082{
1083 TAG_FILES="$@"
1084
1085 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1086 set -x
1087 set -v
cd445739
AM
1088 fi
1089
73ef63d8
ER
1090 echo "Version: $PACKAGE_VERSION"
1091 echo "Release: $PACKAGE_RELEASE"
cd445739 1092
73ef63d8 1093 TAGVER=`make_tagver`
cd445739 1094
73ef63d8
ER
1095 if [ "$TAG_VERSION" = "yes" ]; then
1096 echo "CVS tag: $TAGVER"
1097 fi
1098 if [ -n "$TAG" ]; then
1099 echo "CVS tag: $TAG"
1100 fi
cd445739 1101
39dcc7de 1102 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1103 if [ -n "$CVSROOT" ]; then
1104 OPTIONS="-d $CVSROOT $OPTIONS"
1105 fi
cd445739 1106
73ef63d8
ER
1107 cd "$SOURCE_DIR"
1108 local tag_files
1109 for i in $TAG_FILES; do
1110 # don't tag files stored on distfiles
1111 [ -n "`src_md5 $i`" ] && continue
1112 local fp=`nourl "$i"`
1113 if [ -f "$fp" ]; then
1114 tag_files="$tag_files $fp"
1115 else
1116 Exit_error err_no_source_in_repo $i
03db3356 1117 fi
73ef63d8 1118 done
03db3356 1119
73ef63d8 1120 if [ "$tag_files" ]; then
cd445739 1121 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8
ER
1122 update_shell_title "tag sources: $TAGVER"
1123 cvs $OPTIONS $TAGVER $tag_files
cd445739
AM
1124 fi
1125 if [ -n "$TAG" ]; then
73ef63d8
ER
1126 update_shell_title "tag sources: $TAG"
1127 cvs $OPTIONS $TAG $tag_files
cd445739 1128 fi
73ef63d8
ER
1129 fi
1130
1131 cd "$SPECS_DIR"
1132 if [ "$TAG_VERSION" = "yes" ]; then
1133 update_shell_title "tag spec: $TAGVER"
1134 cvs $OPTIONS $TAGVER $SPECFILE
1135 fi
1136 if [ -n "$TAG" ]; then
1137 update_shell_title "tag spec: $TAG"
1138 cvs $OPTIONS $TAG $SPECFILE
1139 fi
cd445739
AM
1140}
1141
1142branch_files()
1143{
1144 TAG=$1
1145 echo "CVS branch tag: $TAG"
518ff1fb 1146 shift
cd445739
AM
1147
1148 TAG_FILES="$@"
1149
1150 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1151 set -x
1152 set -v
cd445739
AM
1153 fi
1154
78a5a506
ER
1155 local OPTIONS="tag $CVS_FORCE -b"
1156 if [ -n "$CVSROOT" ]; then
1157 OPTIONS="-d $CVSROOT $OPTIONS"
1158 fi
1159 cd "$SOURCE_DIR"
1160 local tag_files
1161 for i in $TAG_FILES; do
1162 local fp=`nourl "$i"`
1163 if [ -f "$fp" ]; then
1164 tag_files="$tag_files $fp"
1165 else
1166 Exit_error err_no_source_in_repo $i
c10fa4fa 1167 fi
78a5a506
ER
1168 done
1169 if [ "$tag_files" ]; then
1170 cvs $OPTIONS $TAG $tag_files
1171 fi
c10fa4fa 1172
78a5a506
ER
1173 cd "$SPECS_DIR"
1174 cvs $OPTIONS $TAG $SPECFILE
cd445739
AM
1175}
1176
1177
3009b80d
ER
1178# this function should exit early if package can't be built for this arch
1179# this avoids unneccessary BR filling.
1180check_buildarch() {
1181 local out ret
1182 out=$($RPMBUILD --short-circuit -bp --define 'prep exit 0' --nodeps $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE 2>&1)
1183 ret=$?
1184 if [ $ret -ne 0 ]; then
1185 echo >&2 "$out"
1186 exit $ret
1187 fi
1188}
1189
cd445739 1190
59398507 1191build_package()
1192{
2e5be021 1193 update_shell_title "build_package"
cd445739 1194 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1195 set -x
1196 set -v
cd445739 1197 fi
5a491465 1198
cd445739
AM
1199 cd "$SPECS_DIR"
1200
1201 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1202 update_shell_title "build_package: try_upgrade"
cd445739 1203 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1204 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1205 else
cc538c24 1206 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1207 fi
1208
1209 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1210
1211 if [ -n "$TNEWVER" ]; then
1212 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1213 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1214 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1215 cp -f $SPECFILE $SPECFILE.bak
1216 fi
cd445739
AM
1217 chmod +w $SPECFILE
1218 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1219 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1220 parse_spec
1221 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1222 update_md5 $SOURCES
975d7b23 1223
cd445739
AM
1224 unset TOLDVER TNEWVER TNOTIFY
1225 fi
1226 fi
1227 cd "$SPECS_DIR"
2a5f078d 1228
cd445739
AM
1229 case "$COMMAND" in
1230 build )
1231 BUILD_SWITCH="-ba" ;;
1232 build-binary )
1233 BUILD_SWITCH="-bb" ;;
1234 build-source )
1235 BUILD_SWITCH="-bs --nodeps" ;;
1236 build-prep )
1237 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1238 build-build )
1239 BUILD_SWITCH="-bc" ;;
1240 build-install )
1241 BUILD_SWITCH="-bi" ;;
1242 build-list )
1243 BUILD_SWITCH="-bl" ;;
1244
cd445739 1245 esac
c890b916 1246
2e5be021 1247 update_shell_title "build_package: $COMMAND"
cd445739
AM
1248 if [ -n "$LOGFILE" ]; then
1249 LOG=`eval echo $LOGFILE`
1250 if [ -d "$LOG" ]; then
1251 echo "Log file $LOG is a directory."
1252 echo "Parse error in the spec?"
518ff1fb 1253 Exit_error err_build_fail
cd445739
AM
1254 fi
1255 if [ -n "$LASTLOG_FILE" ]; then
1256 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1257 fi
1258 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1259 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1260 RETVAL=`cat $RES_FILE`
1261 rm $RES_FILE
1262 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1263 if [ "$RETVAL" -eq "0" ]; then
1264 mv $LOG $LOGDIROK
1265 else
1266 mv $LOG $LOGDIRFAIL
1267 fi
1268 fi
8ba5cdda 1269 else
86aafdbe 1270 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1271 RETVAL=$?
8ba5cdda 1272 fi
cd445739
AM
1273 if [ "$RETVAL" -ne "0" ]; then
1274 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1275 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1276 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1277 mv -f $SPECFILE.bak $SPECFILE
1278 fi
cd445739 1279 fi
518ff1fb 1280 Exit_error err_build_fail
cd445739
AM
1281 fi
1282 unset BUILD_SWITCH
1283}
1284
1285nourl()
1286{
1287 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1288}
1289
cd445739
AM
1290install_required_packages()
1291{
1292 run_poldek -vi $1
1293 return $?
1294}
1295
fa4bf1df
ER
1296find_spec_bcond() {
1297 # taken from find-spec-bcond, but with just getting the list
1298 local SPEC="$1"
1299 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1300 awk -F"\n" '
1301 /^%changelog/ { exit }
1302 /_with(out)?_[_a-zA-Z0-9]+/{
1303 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1304 print substr($0, RSTART, RLENGTH);
1305 }
1306 /^%bcond_with/{
1307 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1308 bcond = substr($0, RSTART +5 , RLENGTH -5);
1309 gsub(/[ \t]+/,"_",bcond);
1310 print bcond
1311 }' $SPEC | LC_ALL=C sort -u
1312}
1313
117d9861 1314process_bcondrc() {
301cbfd4
ER
1315 # expand bconds from ~/.bcondrc
1316 # The file structure is like gentoo's package.use:
1317 # ---
1318 # * -selinux
1319 # samba -mysql -pgsql
47a8df12 1320 # w32codec-installer license_agreement
301cbfd4
ER
1321 # php +mysqli
1322 # ---
fa4bf1df 1323 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1324 :
1325 else
1326 return
1327 fi
301cbfd4 1328
117d9861 1329 SN=${SPECFILE%%\.spec}
c8a3e2ac 1330
117d9861
ER
1331 local bcondrc=$HOME/.bcondrc
1332 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1333
117d9861 1334 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1335
117d9861
ER
1336 while read pkg flags; do
1337 # ignore comments
1338 [[ "$pkg" == \#* ]] && continue
1339
1340 # any package or current package?
1341 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1342 for flag in $flags; do
1343 local opt=${flag#[+-]}
1344
1345 # use only flags which are in this package.
1346 if [[ $bcond_avail = *${opt}* ]]; then
1347 if [[ $flag = -* ]]; then
1348 if [[ $BCOND != *--with?${opt}* ]]; then
1349 BCOND="$BCOND --without $opt"
1350 fi
1351 else
1352 if [[ $BCOND != *--without?${opt}* ]]; then
1353 BCOND="$BCOND --with $opt"
301cbfd4
ER
1354 fi
1355 fi
117d9861
ER
1356 fi
1357 done
1358 fi
1359 done < $bcondrc
1360 update_shell_title "parse ~/.bcondrc: DONE!"
1361}
1362
1363set_bconds_values()
1364{
1365 update_shell_title "set bcond values"
1366
1367 AVAIL_BCONDS_WITHOUT=""
1368 AVAIL_BCONDS_WITH=""
1369 if `grep -q ^%bcond ${SPECFILE}`; then
1370 BCOND_VERSION="NEW"
1371 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
1372 BCOND_VERSION="OLD"
1373 else
1374 return
301cbfd4
ER
1375 fi
1376
117d9861
ER
1377 local bcond_avail=$(find_spec_bcond $SPECFILE)
1378 process_bcondrc "$SPECFILE"
1379
fa4bf1df 1380 update_shell_title "parse bconds"
cd445739 1381 case "${BCOND_VERSION}" in
fa4bf1df 1382 NONE)
7e365483 1383 :
cd445739 1384 ;;
7e365483 1385 OLD)
cd445739 1386 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1387 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1388 do
fa4bf1df
ER
1389 AVAIL_BCOND_WITHOUT=${opt#_without_}
1390 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1391 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1392 else
1393 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1394 fi
1395 done
2a5f078d 1396
fa4bf1df 1397 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1398 do
fa4bf1df
ER
1399 AVAIL_BCOND_WITH=${opt#_with_}
1400 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1401 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1402 else
1403 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1404 fi
1405 done
1406 ;;
1407 NEW)
fa4bf1df
ER
1408 local cond_type="" # with || without
1409 for opt in $bcond_avail; do
cd445739
AM
1410 case "$opt" in
1411 _without)
1412 cond_type="without"
1413 ;;
1414 _with)
1415 cond_type="with"
1416 ;;
f8d24cee 1417 _without_*)
fa4bf1df
ER
1418 AVAIL_BCOND_WITHOUT=${opt#_without_}
1419 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1420 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1421 else
1422 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1423 fi
1424 ;;
1425 _with_*)
fa4bf1df
ER
1426 AVAIL_BCOND_WITH=${opt#_with_}
1427 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1428 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1429 else
1430 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1431 fi
1432 ;;
cd445739
AM
1433 *)
1434 case "$cond_type" in
1435 with)
1436 cond_type=''
1437 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1438 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1439 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1440 else
1441 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1442 fi
7e365483 1443 ;;
cd445739
AM
1444 without)
1445 cond_type=''
1446 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1447 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1448 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1449 else
1450 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1451 fi
1452 ;;
1453 esac
1454 ;;
1455 esac
1456 done
1457 ;;
1458 esac
1459}
1460
1461run_sub_builder()
1462{
1463 package_name="${1}"
af6b168f 1464 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1465 #
1466